﻿Imports System.Text
Imports System.DirectoryServices

Module GetLdapAccts2_BASIC

    Sub Main()

        'Dim de As New DirectoryEntry("LDAP://ldap.ffzg.hr:636/")   ' does not work!!!
        'Dim de As New DirectoryEntry("LDAP://ldap.ffzg.hr:636/dc=hr")   ' does not work!!!
        Dim de As New DirectoryEntry("LDAP://ldap.ffzg.hr:636/uid=pgklada,dc=ffzg,dc=hr")
        de.AuthenticationType = AuthenticationTypes.SecureSocketsLayer  ' use ssl
        'de.Username = "uid=pgklada,dc=ffzg,dc=hr"    ' regular user binding
        'de.Password = "password"
        'de.Username = "cn=admin,dc=ffzg,dc=hr"       ' admin binding
        'de.Password = "password"

        Dim distinguishedName As String
        Try
            distinguishedName = de.Properties("cn")(0)
        Catch ex As Exception
            Console.WriteLine("Can't connect to an LDAP server: " & ex.Message)
            Console.WriteLine("Press any key...")
            Console.ReadKey()
            Exit Sub
        End Try
        Console.WriteLine(distinguishedName)

        ' close the LDAP connection
        If de IsNot Nothing Then
            Try
                de.Close()
                de.Dispose()
            Catch ex As Exception
                Console.WriteLine("Main program has failed to close the startingPointLdapEntry: " &
                                  ex.Message)
            End Try
        End If

        Console.Write("Press any key...") : Console.ReadKey()

    End Sub

End Module
