﻿Module Module1

    Dim ws As New AosiWs.AOSIServicePortTypeClient
    Dim errBuff(1024) As Byte
    Dim resultBuff(10240) As Byte
    Dim wsResult As Integer

    Dim adminUid = "pgklada"
    Dim adminPwd = "password"  ' ovdje dodje password korisnika s ulogom 'administrator imenika'
    Dim baseDn = "dc=ffzg,dc=hr"

    Sub Main()

        System.Net.ServicePointManager.Expect100Continue = False  ' default is true, and it does not work with *my* AOSI service

        ' da biste bili u stanju dodati korisnika u XML konstantu userAddXml treba upisati ispravan OIB !!!

        Console.WriteLine(userExist("pgklada"))
        'Console.WriteLine(ldapAdminInfo("pgklada"))
        'Console.WriteLine(userOrgInfo())
        'Console.WriteLine(ldapSearch("(&(sn=Horvat)(givenName=Ivana))", ""))
        'Console.WriteLine(ldapAddUserLE(userAddXml))
        'Console.WriteLine(ldapDeleteUser(userDeleteXml))
        'Console.WriteLine(ldapModifyAttribute(userModifyAttributeXml))
        'Console.WriteLine(ldapAddAttribute(userAddAttributeXml))
        'Console.WriteLine(ldapDeleteAttribute(userDeleteAttributeXml))

        Console.WriteLine("Press any key...") : Console.ReadKey()

    End Sub

    Function ldapDeleteAttribute(userXml As XElement) As String

        wsResult = ws.ldapDeleteAttribute(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    userXml.ToString
                    )

        Return wsStatus()

    End Function

    Function ldapAddAttribute(userXml As XElement) As String

        wsResult = ws.ldapAddAttribute(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    userXml.ToString
                    )

        Return wsStatus()

    End Function

    Function ldapModifyAttribute(userXml As XElement) As String

        wsResult = ws.ldapModifyAttribute(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    userXml.ToString
                    )

        Return wsStatus()

    End Function

    Function ldapDeleteUser(userXml As XElement) As String

        wsResult = ws.ldapDeleteUser(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    userXml.ToString
                    )

        Return wsStatus()

    End Function

    Function ldapAddUserLE(userXml As XElement) As String

        wsResult = ws.ldapAddUserLE(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    userXml.ToString
                    )

        Return wsStatus()

    End Function

    Function ldapSearch(filter As String, fields As String) As String

        wsResult = ws.ldapSearch(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    filter, fields)

        Return wsStatus()

    End Function

    Function userOrgInfo() As String

        wsResult = ws.userOrgInfo(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn
                    )

        Return wsStatus()

    End Function

    Function ldapAdminInfo(uid As String) As String

        wsResult = ws.ldapAdminInfo(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    uid
                    )

        Return wsStatus()

    End Function

    Function userExist(uid As String) As String

        wsResult = ws.ldapUserExists(
                    errBuff, resultBuff,
                    adminUid, Encode64(adminPwd), baseDn,
                    uid)

        Return wsStatus()

    End Function

    Function wsStatus() As String

        Dim s = wssStatus()
        My.Computer.Clipboard.SetText(s)
        Return s

    End Function

    Function wssStatus() As String

        If wsResult = 0 Then
            Return "result 0: " & vbCrLf &
                XDocument.Parse(
                    System.Text.Encoding.UTF8.GetString(resultBuff)
                    ).ToString
        ElseIf wsResult > 0 Then
            Return "LDAP error " & wsResult & ": " & System.Text.Encoding.UTF8.GetString(errBuff)
        Else
            Return "AOSI error " & wsResult & ": " & System.Text.Encoding.UTF8.GetString(errBuff)
        End If

    End Function

    Function Encode64(s As String) As String

        Return System.Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(s))

    End Function

    Dim userAddXml =
        <ldap action="ldapAddUser">
            <entry dn="uid=pgklada2,dc=ffzg,dc=hr">
                <attribute ldapname="cn">
                    <value>Gjuro Kladarić</value>
                </attribute>
                <attribute ldapname="givenName">
                    <value>Gjuro</value>
                </attribute>
                <attribute ldapname="hrEduPersonAffiliation">
                    <value>djelatnik</value>
                </attribute>
                <attribute ldapname="hrEduPersonExpireDate">
                    <value>NONE</value>
                </attribute>
                <attribute ldapname="hrEduPersonPrimaryAffiliation">
                    <value>djelatnik</value>
                </attribute>
                <attribute ldapname="hrEduPersonUniqueNumber">
                    <value>OIB: [OVDJE TREBA UPISATI ISPRAVAN OIB!!!] </value>
                </attribute>
                <attribute ldapname="mail">
                    <value>pgklada2@ffzg.hr</value>
                </attribute>
                <attribute ldapname="sn">
                    <value>Kladarić</value>
                </attribute>
                <attribute ldapname="uid">
                    <value>pgklada2</value>
                </attribute>
                <attribute ldapname="userPassword">
                    <value>jaSamMaliMishKojiNeZnaNish</value>
                </attribute>
            </entry>
        </ldap>

    Dim userDeleteXml =
        <ldap action="ldapDeleteUser">
            <entry dn="uid=pgklada2,dc=ffzg,dc=hr">
            </entry>
        </ldap>

    Dim userModifyAttributeXml =
        <ldap action="ldapModifyAttribute">
            <entry dn="uid=pgklada2,dc=ffzg,dc=hr">
                <attribute ldapname="hrEduPersonExpireDate">
                    <value>20121231</value>
                </attribute>
            </entry>
        </ldap>

    Dim userAddAttributeXml =
        <ldap action="ldapAddAttribute">
            <entry dn="uid=pgklada2,dc=ffzg,dc=hr">
                <attribute ldapname="mobile">
                    <value>099/999-9999</value>
                </attribute>
            </entry>
        </ldap>

    Dim userDeleteAttributeXml =
        <ldap action="ldapDeleteAttribute">
            <entry dn="uid=pgklada2,dc=ffzg,dc=hr">
                <attribute ldapname="mobile">
                </attribute>
            </entry>
        </ldap>

End Module
